---
title: Mouse controls
slug: Games/Tutorials/2D_Breakout_game_pure_JavaScript/Mouse_controls
tags:
  - Beginner
  - Canvas
  - Controls
  - Games
  - JavaScript
  - Tutorial
  - mouse
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Track_the_score_and_win", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Finishing_up")}}</p>

<div class="summary">
<p>This is the <strong>9th step</strong> out of 10 of the <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch">Gamedev Canvas tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Canvas-workshop/blob/gh-pages/lesson09.html">Gamedev-Canvas-workshop/lesson9.html</a>.</p>
</div>

<p><span class="seoSummary">The game itself is actually finished, so let's work on polishing it up. We have already added keyboard controls, but we could easily add mouse controls too.</span></p>

<h2 id="Listening_for_mouse_movement">Listening for mouse movement</h2>

<p>Listening for mouse movement is even easier than listening for key presses: all we need is the listener for the {{event("mousemove")}} event. Add the following line in the same place as the other event listeners, just below the <code>keyup event</code>:</p>

<pre class="brush: js notranslate">document.addEventListener("mousemove", mouseMoveHandler, false);</pre>

<h2 id="Anchoring_the_paddle_movement_to_the_mouse_movement">Anchoring the paddle movement to the mouse movement</h2>

<p>We can update the paddle position based on the pointer coordinates — the following handler function will do exactly that. Add the following function to your code, below the previous line you added:</p>

<pre class="brush: js notranslate">function mouseMoveHandler(e) {
    var relativeX = e.clientX - canvas.offsetLeft;
    if(relativeX &gt; 0 &amp;&amp; relativeX &lt; canvas.width) {
        paddleX = relativeX - paddleWidth/2;
    }
}</pre>

<p>In this function we first work out a <code>relativeX</code> value, which is equal to the horizontal mouse position in the viewport (<code>e.clientX</code>) minus the distance between the left edge of the canvas and left edge of the viewport (<code>canvas.offsetLeft</code>) — effectively this is equal to the distance between the canvas left edge and the mouse pointer. If the relative X pointer position is greater than zero and lower than the Canvas width, the pointer is within the Canvas boundaries, and the <code>paddleX</code> position (anchored on the left edge of the paddle) is set to the <code>relativeX</code> value minus half the width of the paddle, so that the movement will actually be relative to the middle of the paddle.</p>

<p>The paddle will now follow the position of the mouse cursor, but since we're restricting the movement to the size of the Canvas, it won't disappear completely off either side.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>This is the latest state of the code to compare against:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/raymondjplante/vt7y5hcp/","","395")}}</p>

<div class="summary">
<p>Exercise: adjust the boundaries of the paddle movement, so the whole paddle will be visible on both edges of the Canvas instead of only half of it.</p>
</div>

<h2 id="Next_steps">Next steps</h2>

<p>Now we've got a complete game we'll finish our series of lessons with some more small tweaks — <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch/Finishing_up">Finishing up</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Track_the_score_and_win", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Finishing_up")}}</p>
